/*
 Copyright:      Hagen Reddmann  mailto HaReddmann at T-Online dot de
 Author:         Hagen Reddmann
 Remarks:        this Copyright must be included
 known Problems: none
 Version:        2.1. 2004
 Description:    Graphic Library for Nokia 6100 Display and compatible
*/

.nolist
#include "glcd.inc"
#include "regs.inc"
.list

        .text
		.section .progmem
Orientation_values:
        .byte   ORIENTATION_0 //(1 << MEM_VW)	// Orientation 0
        .byte   ORIENTATION_90 //(1 << MEM_MX) | (1 << MEM_90)	// Orientation 90
        .byte   ORIENTATION_180 //(1 << MEM_MX) | (1 << MEM_180)	// Orientation 180
        .byte   ORIENTATION_270 //(1 << MEM_MY) | (1 << MEM_180) | (1 << MEM_90)	// Orientation 270

        .section .text
        .global glcdSetOrientation     // used T0, T1 stack 1
glcdSetOrientation:
        andi    P0, 3
        lds     T1, glcd_MemCtrl
        eor     T1, P0
        sbrs    T1, MEM_90
        fjmp     glcdSetOrientation1
        push    P0
        lds     T1, glcd_Clip_X1
        lds     P0, glcd_Clip_Y1
        sts     glcd_Clip_X1, P0
        sts     glcd_Clip_Y1, T1
        lds     T1, glcd_Clip_X2
        lds     P0, glcd_Clip_Y2
        sts     glcd_Clip_X2, P0
        sts     glcd_Clip_Y2, T1
        pop	P0
glcdSetOrientation1:
        // Done


		ldi		ZL, lo8(Orientation_values)
		ldi		ZH, hi8(Orientation_values)
		add		ZL, P0
		brcc	glcdSetOrientation2
		inc		ZH
glcdSetOrientation2:
		lpm		T1, Z

//		pop P0
//		mov		T1, P0

        sts     glcd_MemCtrl, T1
        fjmp    glcdDispData

/* 
        lds     T1, glcd_MemCtrl
        andi    T1, ~((1 << MEM_90) | (1 << MEM_180) | (1 << MEM_VW) | (1 << MEM_MX) | (1 << MEM_MY))
        or      P0, T1
        ldi     T1, MEM_CONTROL
        fcall   glcdDispCommand
        sbrc    P0, MEM_90
        ori     P0, (1 << MEM_VW) | (1 << MEM_MX)
        ldi     T1, (1 << MEM_MY)
        sbrs    P0, MEM_180
        ldi     T1, (1 << MEM_MX)
        eor     T1, P0
        sts     glcd_MemCtrl, T1
        fjmp    glcdDispData
*/
.end
